function [vari,dom,FF,ff]=apelo(rutaim,rutacon,rutafun,N,NIVRES,CRIT,PARAM);

% APELO carga las N imagenes .raw almacenadas en la ruta 'RUTAIM',
% calcula los contrastes contenidos en los subbloques de nivel de 
% resolucion NIVRES segun el criterio de normalizacion CRIT utilizando
% si es necesario el parametro PAR (ver help de ampldct2.m) y guarda
% los resultados de los contrastes en ficheros numerados en 'RUTACON'
%
% Hecho esto, carga los ficheros resultantes y calcula la funcion 
% de distribucion de probabilidad (y la funcion densidad) para el
% contraste de cada coeficiente y su varianza.
%
% APELO devuelve un vector con la varianza de los contrastes de los
% coeficientes, una matriz con los dominios de las funciones densidad 
% y distribucion, y estas funciones.
%
% Como las funciones densidad y distribucion se estiman a partir de
% histogramas con numeros diferentes de intervalos, los vectores con
% los datos de f y F tienen longitudes diferentes. Para meterlos todos
% en una misma matriz se rellenan con 40's los vectores mas cortos.
% Cada fila de las matrices resultantes corresponde a un coeficiente frecuencial.
%
% Estos datos (vari,dom,FF,ff) se almacenan en 'rutafun'
%
% USO: [vari,dom,FF,ff]=apelo('rutaim','rutacon','rutafun',N,NIVRES,CRIT,PARAM);

for i=1:N
    ima=[rutaim,int2str(i),'.mat']
%    ima=[rutaim,int2str(i),'.raw']
    im=cargaim(ima,256,256,0,'char');
    if i==1
       ampldct2(im,NIVRES,rutacon,0,CRIT,PARAM);
    else
       ampldct2(im,NIVRES,rutacon,1,CRIT,PARAM);
    end
    [1 i]
end

tam=size(im);
clear im
lcuan=tam(1)/(2^NIVRES);
num=floor(sqrt((lcuan-1)^2+(lcuan-1)^2))+1;

for i=1:num
    eval(['load ',rutacon,int2str(i)])
    [2 i]
end

for i=1:num
    eval(['[dom',int2str(i),',f',int2str(i),',F',int2str(i),',vari(i)]=iafstad2(abs(C',int2str(i),'),floor(sqrt(length(C',int2str(i),'))),floor(sqrt(length(C',int2str(i),'))));']);
    eval(['lo(i)=length(f',int2str(i),');']);
    eval(['do(i)=maxi(dom',int2str(i),');']);
    [3 i]
end 
lm=max(lo);
dm=max(do);

for i=1:num
    if i==1
       dom(1,:)=[dom1 10*dm*ones(1,lm-length(dom1))];
       FF(1,:)=[F1 10*dm*ones(1,lm-length(F1))];
       ff(1,:)=[f1 10*dm*ones(1,lm-length(f1))];
    else
       eval(['dom(i,:)=[dom',int2str(i),' 10*dm*ones(1,lm-length(dom',int2str(i),'))];']);
       eval(['FF(i,:)=[F',int2str(i),' 10*dm*ones(1,lm-length(F',int2str(i),'))];']);
       eval(['ff(i,:)=[f',int2str(i),' 10*dm*ones(1,lm-length(f',int2str(i),'))];']);
    end
    [3 i]
end

eval(['save ',rutafun,' vari FF ff dom'])