function [t,p]=asignbbb(tt,niv,fro,crit);

%'ASIGNBBB' asigna al valor 'valorviejo' uno de los valores del conjunto de 
% niveles 'niv' posibles segun el criterio 'crit'. 
% Ojo: 'valorviejo' debe estar entre 0 y 1.
%
% Criterios de asignacion:
%
%         -Asignacion al mas proximo..................Crit=1
%
%         -Asignacion al inmediatamente inferior......Crit=2
%
%         -Asignacion segun distancia de Mahalanobis..Crit=3
%          (Requiere fronteras de Mahalanobis)
%
% USO: [valornuevo,posicion]=asignbbb(valorviejo,niveles,fronteras,crit);
 
if niv(1)==-1
   t=tt;
   p=tt;              % Si no se cuantiza, en el codigo aparece explicitamante el valor...
else 
   nivt=abs(niv-tt);
   [m,n]=min(nivt);
   if crit==2
      if ((tt<niv(n)) & (n>1))
   	   t=niv(n-1);
           p=n-2; 
      else
           t=niv(n);
           p=n-1;
      end
   elseif crit==3
      front=abs(fro-tt);
      [mm,nn]=min(front);
      if tt<fro(nn)
         t=niv(nn);
         p=nn-1;
      else
         t=niv(nn+1);
         p=nn; 
      end          
   else
      t=niv(n);
      p=n-1;
   end
end


    
