function [iaf,ciaft,ciafe,nuqf,csfet]=constet(fe,facfrec,ft,C,ap,sta)

% CONSTET calcula la IAF del sistema visual en el dominio de frecuencias 
% espaciales o espacio-temporales y amplitud de la DCT
% Podemos seleccionar diferentes parametros:
%
%   - Dominio frecuencial: vectores fe, ft y factor facfrec
%   - Dominio de amplitud: vector C
%   - Linealidad (o no linealidad) en amplitud de la IAF
%   - Tipo de CIAF (anchos de banda espacio-temporales)
%   - Estabilizacion o no estabilizacion en el caso de ft~=0 
%
% USO: [iaf,ciaft,ciafe,nuqf,csfet]=constet(fe,facfrec,ft,C,[iafnolin?(0/1) ciafnolin?(0/1) log(CIAF)(0/1)],estabiliz?(0/1)));
%
% NOTA: fe debe ser un vector columna y C debe ser un vector fila!
%       ft debe ser un vector (da igual como)
%       facfrec ~ 1 (ver iafet)
%

iaf=[];
csfet=[];
for i=1:length(ft)
     [ia,a]=iafet(fe,facfrec,ft(i),C,ap,sta);
     iaf=[iaf ia'];
     csfet=[csfet a];
end

iaf=iaf-mini(iaf);   % Porque?

ciafe=sum(iaf);


%%%%%%%%% PRUEBA 29 Julio 

if length(ap)==1
   ap=[ap 0 0];
elseif length(ap)==2
   ap=[ap 0];
end

if ap(3)==1
   a=ciafe.*(ciafe>0);
   v=find(ciafe>0);
   a(v)=log(a(v))/log(2);
   a(v)=a(v)-min(a(v));
   ciafe(v)=a(v);
end
                          
%%%%%%%%%                 

for i=1:length(ft)
    cia=sacafot(ciafe,1,length(fe),i);
    ciaft(i)=sum(cia);
end
nuqf=cumsum(iaf);