function [c,AA,BB]=correpto(A,B,p,v,D,inte)

% CORREPTO multiplica e integra las vecindades [M N] del punto [i+di j+dj] de S(t)
% y del punto [i j] de S(t-1).
% Es decir, CORREPTO calcula la correlacion de la vecindad [M N] en torno al punto 
% [i j] en el momento t-1 con la vecindad del punto correspondiente del fotograma 
% siguiente asumiendo un desplazamiento D=[di dj] de dicho punto.
%
% USO: [c,Vecind_S(t),Vecind_S(t-1)]=correpto(s(t),s(t-1),[i j],[M N],[di dj],interpola?);


AA=sacasub(A,p+D,v,inte);
BB=sacasub(B,p,v,inte);

EAA=sqrt(sum(sum(AA.^2)));
EBB=sqrt(sum(sum(BB.^2)));
if EAA*EBB>0
   c=sum(sum(AA.*BB))/(EAA*EBB);
else
   c=sum(sum(AA.*BB));
end