function e=esta(n,posn,blocs,N,l)

% ESTA indica si el subbloque (posn) del nivel de resolucion n esta 'presente' en la
% descomposicion en arbol definida por el vector blocs. 
%
% Si el subbloque indicado pertenece a un bloque no dividido de un nivel de resolu-
% cion inferior o esta dividido en subbloques pertenecientes a niveles de resolucion
% superiores, la respuesta es e=0.
%
% En caso contrario la respuesta es e=1. 
%
% USO: e=esta(n,posn,blocs,niv_resol_max,l);

if n-1>0
    ll=l(n-1)+posn;                    % Posicion del subbloque en el vector blocs
else
    ll=posn;
end
c1=blocs(ll);                      % Valor del elemento de blocs correspondiente
                                   %       (este valor nos dice si ese subbloque esta dividido, si esta dividido
                                   %        el subbloque no estara presente)

if n-1>0
    corn=coord(posn,[2^n 2^n]);
    cornm(1,1)=0.5*(corn(1)-1)+1;
    cornm(1,2)=0.5*(corn(2)-1)+1;
    cornm(2,1)=0.5*(corn(1)-2)+1;
    cornm(2,2)=0.5*(corn(2)-1)+1;
    cornm(3,1)=0.5*(corn(1)-1)+1;
    cornm(3,2)=0.5*(corn(2)-2)+1;
    cornm(4,1)=0.5*(corn(1)-2)+1;
    cornm(4,2)=0.5*(corn(2)-2)+1;
    a=cornm-floor(cornm);
    a=double(a==0);
    a=prod(a');
    [a,p]=max(a);
    cornm=cornm(p,:);                         % Coordenadas (en el nivel n-1) del bloque que contiene a nuestro subbloque 

    posnm=posicion(cornm,[2^(n-1) 2^(n-1)]);  % Posicion (en el nivel n-1) del bloque que contiene a nuestro subbloque 

    if n-2>0
         ll=l(n-2)+posnm;              % Posicion (en el vector blocs) del bloque que contiene a nuestro subbloque 
    else
         ll=posnm;
    end
    c2=blocs(ll);                      % Valor del elemento de blocs correspondiente
                                       %       (este valor nos dice si el bloque esta dividido, si no esta dividido
                                       %        el subbloque no estara presente)
else
    c2=1;                              % Si estamos en el nivel 1, el bloque que contiene a nuestro subbloque siempre
                                       % esta dividido, con lo cual, c2=1.
end

if (c1<1)&(c2>0)
   e=1;
else
   e=0;
end