function fn=monotono(f)

%'MONOTONO' convierte una secuencia monotona (xi>=xi-1) 
% en una secuencia estrictamente monotona (xi>xi-1).
% (Asi ya se puede meter en interp1)
% 
% USO: fem=monotono(fm);
% 
% ATENCION! Lo que hace es interpolar linealmente entre el punto
% anterior y el posterior a la meseta. Si la meseta esta al final de
% la secuencia, interpola linealmente entre el punto anterior a la 
% meseta y el ultimo.
% Eso provoca que en el puetero caso de que haya dos mesetas seguidas
% al final de la secuencia p.ej.: [1 2 3 3 4 4] el programa de:
%
%                         [1 2 3 3.5 3.5 4]
%
% Para evitar esos efectos, aplicar dos veces 'MONOTONO'  

[x,y]=size(f);
if x>y
	f=f';
end
marca=0;
num_ptos=length(f);
if num_ptos<20
   marca=1;
   npint=10;
   xx=linspace(1,num_ptos,num_ptos+(num_ptos-1)*npint);
   f=(interp1(linspace(1,num_ptos,num_ptos),f,xx));
   if sum(f==f(1))==length(f)
      f(1)=0;
      f(2)=0.8*f(3);
      f(3)=0.9*f(4);       
   end
end

a=0;
r=0;
while (f(1)==0)|(f(length(f))==0)
   f=f-a;
   a=rand(1,1);
   f=f+a;
   r=1;
end

x1=[0 f];
x2=[f 0];
cre=x2-x1;
cre(1:length(cre)-1);
cond=(cre==0);

if sum(cond)>0
   aa=0;
   c=[cond 0]-[0 cond];
   ini=find(c==1);
   fin=find(c==-1);
   longit=fin-ini;
   nn=length(ini);
   g=[1 fin];
   if fin(nn)<length(f)+1
       for i=1:nn,
          aa=[aa f(g(i):ini(i)-1) f(ini(i)-1)+linspace(1,longit(i),longit(i))*((f(fin(i))-f(ini(i)-1))/(longit(i)+1))];
       end
       aa=[aa f(fin(nn):length(f))];
       fn=aa(2:length(aa));
   else
       if length(fin)>1 
          if (fin(length(fin)-1)+1)<ini(length(ini))
              for i=1:nn-1   
                  aa=[aa f(g(i):ini(i)-1) f(ini(i)-1)+linspace(1,longit(i),longit(i))*((f(fin(i))-f(ini(i)-1))/(longit(i)+1))];
              end
              aa=[aa f(g(nn):ini(nn)-2) f(ini(nn)-2)+linspace(1,longit(nn),longit(nn))*((f(fin(nn)-1)-f(ini(nn)-2))/(longit(nn)+1))];      
              fn=[aa(2:length(aa)) f(length(f))]; 
          else
              for i=1:nn-1   
                  aa=[aa f(g(i):ini(i)-1) f(ini(i)-1)+linspace(1,longit(i),longit(i))*((f(fin(i))-f(ini(i)-1))/(longit(i)+1))];
              end
              aa=[aa aa(length(aa))+linspace(1,longit(nn),longit(nn))*((f(fin(nn)-1)-aa(length(aa)))/(longit(nn)+1))];      
              fn=[aa(2:length(aa)) f(length(f))];      
          end
       else
          for i=1:nn-1   
               ini(i)
               aa=[aa f(g(i):ini(i)-1) f(ini(i)-1)+linspace(1,longit(i),longit(i))*((f(fin(i))-f(ini(i)-1))/(longit(i)+1))];
          end
          aa=[aa f(g(nn):ini(nn)-2) f(ini(nn)-2)+linspace(1,longit(nn),longit(nn))*((f(fin(nn)-1)-f(ini(nn)-2))/(longit(nn)+1))];      
          fn=[aa(2:length(aa)) f(length(f))];
       end
   end 
else
    fn=f;   
end

if r==1
   fn=fn-a;
end         

if marca==1
   l=1;
   for i=1:num_ptos
       ff(i)=fn(l);
       l=l+npint+1;
   end
   fn=ff;
end 