function [POS1,POS2]=pintafl2(D,pos,centro,lado,facto,facf,colo,gordo,fig)

% PINTAFL2 representa el flujo optico a partir de los datos (no redundantes) dados por
% los programas de estimacion del flujo (p.ej. FLUJO1).
%
% PINTAFL2 representa los vectores desplazamiento de cada subbloque en la figura 'fig'
% multiplicados un factor 'fac'.
%
% Permite representar una region dentro de la imagen. La region es
% un rectangulo definido por su 'centro' y sus 'lados'.
%
%
% USO: pintafl2(Despl,posic,centro,lados,facD,tam_flech,[color],grosor,fig);

c=(D'==0);

figure(fig),axis([1 lado(2) 1 lado(1)]),axis('equal'),axis('ij'),axis('off'),
s=size(pos);

lims1=[centro(1)-lado(1)/2 centro(2)-lado(2)/2];
lims2=[centro(1)-lado(1)/2 centro(2)+lado(2)/2];
limi1=[centro(1)+lado(1)/2 centro(2)-lado(2)/2];
limi2=[centro(1)+lado(1)/2 centro(2)+lado(2)/2];
        
for i=1:s(1)
    if (pos(i,1)>=lims1(1))&(pos(i,1)<=limi2(1))&(pos(i,2)>=lims1(2))&(pos(i,2)<=lims2(2))
       if sum(D(i,:)==[0 0])==2

          inc=0.3;
          POS1=pos(i,:)'-lims1';
          POS2=POS1+[0 inc]';
          POS3=POS1+[inc inc]';
          POS4=POS1+[inc 0]';
   
          a=line([POS1(2);POS2(2)],[POS1(1);POS2(1)]);set(a,'Color',colo,'LineWidth',gordo);
          a=line([POS2(2);POS3(2)],[POS2(1);POS3(1)]);set(a,'Color',colo,'LineWidth',gordo);
          a=line([POS3(2);POS4(2)],[POS3(1);POS4(1)]);set(a,'Color',colo,'LineWidth',gordo);
          a=line([POS4(2);POS1(2)],[POS4(1);POS1(1)]);set(a,'Color',colo,'LineWidth',gordo);
       else
          POS1=pos(i,:)'-lims1';
          POS2=pos(i,:)'+facto*D(i,:)'-lims1';
           
          % La flechita!!
          
          v=-D(i,:)./[sqrt(sum((D(i,:).^2)'))' sqrt(sum((D(i,:).^2)'))'];
          u=[v(:,2) -v(:,1)];
          
          POS3=POS1+facto*D(i,:)'+facf*(v'+0.5*u');
          POS4=POS1+facto*D(i,:)'+facf*(v'-0.5*u');
          
          a=line([POS1(2,:);POS2(2,:)],[POS1(1,:);POS2(1,:)]);set(a,'Color',colo,'LineWidth',gordo);
          a=line([POS2(2,:);POS3(2,:)],[POS2(1,:);POS3(1,:)]);set(a,'Color',colo,'LineWidth',gordo);
          a=line([POS2(2,:);POS4(2,:)],[POS2(1,:);POS4(1,:)]);set(a,'Color',colo,'LineWidth',gordo);
       end
   end
end    

% b=line([1;1],[1;lado(2)]);set(b,'Color',colo);
% b=line([1;lado(1)],[lado(2);lado(2)]);set(b,'Color',colo);
% b=line([lado(1);lado(1)],[lado(2);1]);set(b,'Color',colo);
% b=line([lado(1);1],[1;1]);set(b,'Color',colo);

b=line([1;1],[1;lado(1)]);set(b,'Color',colo,'LineWidth',gordo);
b=line([1;lado(2)],[lado(1);lado(1)]);set(b,'Color',colo,'LineWidth',gordo);
b=line([lado(2);lado(2)],[lado(1);1]);set(b,'Color',colo,'LineWidth',gordo);
b=line([lado(2);1],[1;1]);set(b,'Color',colo,'LineWidth',gordo);


% dd=sum((pos.^2)');
% dd=(dd==0);
% dd=filter([1 -1],1,dd);
% [m,po]=max(dd);
% if m==0
%    po=length(dd)+1;
% end
% for i=1:po-1
%    if sum(D(i,:).^2)>0
%       figure(fig),plot([pos(i,2);pos(i,2)+fac*D(i,2)],[pos(i,1);pos(i,1)+fac*D(i,1)],'r-'),
%       axis([1 lado 1 lado]),axis('ij'),ax,hold on    
%    else
%       figure(fig),plot(pos(i,2),pos(i,1),'r.'),axis([1 lado 1 lado]),ax,axis('ij'),hold on    
%    end
% end