function B=predigo(A,D,pos,lado);

% PREDIGO estima el fotograma k+1 a partir del fotograma anterior (k) y de la
% informacion del movimiento (campo de vectores de desplazamiento).
%
% El estimador de sk es sk', dado por: 
%
%                        sk'(x+Dk(x)) = sk-1(x) 
%
% Los vectores de desplazamiento que se introducen representan el movimiento de
% determinadas regiones rectangulares de la imagen sk-1.
% A diferencia de lo que ocurre en PREDICE, aqui los vectores desplazamiento se dan
% de 'forma no redundante' hace falta dar la posicion (punto central) y el lado de
% cada subbloque considerado.
% 
% USO: sk'=predigo(sk-1,despl,posiciones,lado);
%
% NOTA: 'bloques' es un vector de longitud sum_(n=1:NN-1)[2^(2*n)] donde NN es el nivel de 
%        resolucion.

s=size(D);

B=A;
for i=1:s(1)
    AA=sacasub(A,pos(i,:),lado(i,:),0);
    B=metesub(B,pos(i,:)+floor(D(i,:)),AA);
end