function [imq,dctq,codq,ciaf1D,iaf,nuqf,niveles,fronteras,H,Hi]=qdct55(s,Ncuan,opc,niveles,fronteras,facfrec,ncontr,nolin,estab,B,bitmax,met,fchest,fc,cc,crit,fijarmax,inclcsf,frecbaja,calcent,norm);
                      
% QDCT55 cuantiza las DCTs de los subbloques de resolucion N de una seal 2D
%               
% QDCT55 permite 'disear' el VQ segun la IAF o estadstico, o introducir algun cuantizador 
% diseado previamente (contiene APELES Y VQPERC, y QDCT21)
%
% Para elegir calcular el VQ PERCEPTUAL introducir un 1 en la variable 'opc'.
% En este caso habra que pasar los parametros necesarios para el diseo del VQ (Ver VQPERC.M). 
%  * Cuantizacion con calculo del VQ perceptual necesita:
%         seal,Ncuan,opc?=1,facfrec,ncontr,nolin?,estab?,
%           B,bitmax,fc,cc,crit,fijarmax?,inclcsf?,frecbaja.
% 
% Para calcular el VQ ESTADISTICO introducir un 2 en la variable 'opc'.
% Idem pasar los parametros necesarios para el diseo del VQ (Ver APELES.M).
%  * Cuantizacion con calculo estadistico necesita:
%         seal,Ncuan,opc=?2,B,bitmax,fchest,fc,cc,crit,frecbaja
%         (fchest(fichero estadisticas con vari, ff, FF).)
%         Podemos elegir introducir un primer escalon perceptual imponiendo
%         la CSF (inclcsf=1).
%         Lo que se aplica es el primer intervalo del cuantizador perceptual
%         para cada coeficiente. Por tanto, si inclcsf==1, habra que rellenar
%         los parametros del cuantizador perceptual.
%
% En caso de utilizar un VQ previamente calculado (cero en opc), habra que pasar los
% parametros del cuantizador: niveles y fronteras.
%  * Cuantizacion con VQ previamente calculado necesita:
%         seal,Ncuan,opc?=0,niveles,fronteras,fc,cc,crit,frecbaja.
%
% Podemos elegir entre diferentes normalizaciones de los coeficientes de la DCT:
%
%   Norm = 1 ......... Normalizamos mediante la luminancia media del subbloque considerado.
%
%   Norm = 2 ......... Normalizamos mediante la luminancia media del subbloque considerado y
%                      de los subbloques del entorno. Hay que introducir como parametro que
%                      numero de subbloques queremos tomar de entorno.
%
%   Norm = 3 ......... Normalizamos mediante la luminancia media de toda la imagen.
%
%   Norm = 4 ......... Normalizamos mediante el valor introducido como parametro (valor*N^2).
%
%   Norm = 5 ......... Trabajamos con amplitudes, no con contrastes.      
%
% USO: [imq,dctq,cod,ciaf1D,iaf,nuqf,niveles,fronteras,H,Hi]=qdct55(seal,Ncuan,opc(1/0)?,niveles,fronteras,
%      facfrec,ncontr,nolin(1/0),estab(1/0),B,bitmax,metod,fiche_estad,fc,cc,crit,fijarmax(0/1),[inclcsf(0/1) fact_umbral],
%      frecbaja,calc_entrop?,[Norm parametro]);
%

   par=norm(2);
   norm=norm(1);
   tam=size(s);
   tam=tam(1);
   lados=[tam tam];
   imq=zeros(tam,tam);
   dctq=zeros(tam,tam);
   codq=zeros(tam,tam);
   lcuan=tam/(2^Ncuan);
   posai=[tam tam]/2-round(tam/2);
   posbd=[tam tam]/2+round(tam/2);
   coorcuanai=floor([(posai(1)-1)/lcuan+1 (posai(2)-1)/lcuan+1]);
   coorcuanbd=floor([(posbd(1)-1)/lcuan+1 (posbd(2)-1)/lcuan+1]);
   if coorcuanai(1)<1
        coorcuanai(1)=1;
   end 
   if coorcuanai(2)<1
        coorcuanai(2)=1;
   end 
   if coorcuanbd(1)>(2^Ncuan)
        coorcuanbd(1)=2^Ncuan;
   end     
   if coorcuanai(2)>(2^Ncuan)
        coorcuanbd(2)=2^Ncuan;
   end 
    
   H=0;    
   Hi=0;   

   if (opc==2)
	[iaf,ciaf1D,niveles,fronteras]=apeles(B,bitmax,met,fchest);
        if inclcsf(1)==1  
           [ciaf1Dp,iafp,nuqfp,nivelesp,fronterasp]=vqperc(lcuan,facfrec,ncontr,nolin,estab,B,bitmax,fc,fijarmax,0);
           fronterasp=fronterasp*(lcuan^2)*128;
           % OJO, DEBERIA PASARSE DE CONTRASTES A AMPLITUDES MEDIANTE LA MEDIA DEL NIVEL DE GRIS, NO MEDIANTE 128!!
           tamfro=size(fronteras);
           for i=1:tamfro(1)
               if niveles(i,1)~=-1
                  condic=(fronteras(i,:)<=(inclcsf(2)*fronterasp(i,1)));
                  if (sum(condic)~=0)
                     v=find(condic<1);
                     l=length(v);
                     if l>1
                        front=[fronteras(i,v) maxi(fronteras(i,:))*ones(1,tamfro(2)-l)];
                        nivel=[0 niveles(i,v(2:l)) maxi(niveles(i,:))*ones(1,tamfro(2)-l+1)];
                        fronteras(i,:)=front;
                        niveles(i,:)=nivel;
                     else
                        fronteras(i,:)=maxi(fronteras(i,:))*ones(1,tamfro(2));
                        niveles(i,:)=[0 maxi(niveles(i,:))*ones(1,tamfro(2))];
                     end
                  end
               else
                  fronteras(i,:)=fronteras(i,:);
                  niveles(i,:)=niveles(i,:);
               end      
           end
        end
   elseif (opc==1)
	[ciaf1D,iaf,nuqf,niveles,fronteras]=vqperc(lcuan,facfrec,ncontr,nolin,estab,B,bitmax,fc,fijarmax,0);
   end
   for ii=coorcuanai(1):coorcuanbd(1)
       for jj=coorcuanai(2):coorcuanbd(2)

           iii=(ii-1)*lcuan+ceil(lcuan/2);
           jjj=(jj-1)*lcuan+ceil(lcuan/2); 
           blo=sacasub(s,[iii jjj],[lcuan lcuan],0);
           cubs=dct2(blo);
           cub=cubs;
           fla=0;
           if cub(1,1)==0
              fla=1;
              cub(1,1)=10;
           end
              if norm==1
                 cub(2:lcuan,1)=2*cub(2:lcuan,1)/cub(1,1);
                 cub(1,2:lcuan)=2*cub(1,2:lcuan)/cub(1,1);
                 cub(2:lcuan,2:lcuan)=4*cub(2:lcuan,2:lcuan)/cub(1,1);
%                cub(1,1)=cub(1,1)/(4*lcuan^2);
              elseif norm==2
                 Lmed=[];
                 for k=-par:par
                     for l=-par:par
                         cubil=sacasub(s,[iii+k jjj+l],[lcuan lcuan],0);
                         med=mean(mean(cubil));
                         if med>0
                            Lmed=[Lmed med];
                         end 
                     end
                 end 
                 Lmedia=4*mean(Lmed)*lcuan^2;
                 cub(2:lcuan,1)=2*cub(2:lcuan,1)/Lmedia;
                 cub(1,2:lcuan)=2*cub(1,2:lcuan)/Lmedia;
                 cub(2:lcuan,2:lcuan)=4*cub(2:lcuan,2:lcuan)/Lmedia;
%                cub(1,1)=cub(1,1)/(4*lcuan^2);
              elseif norm==3
                 cub(2:lcuan,1)=2*cub(2:lcuan,1)/Lmedia;
                 cub(1,2:lcuan)=2*cub(1,2:lcuan)/Lmedia;
                 cub(2:lcuan,2:lcuan)=4*cub(2:lcuan,2:lcuan)/Lmedia;
%                cub(1,1)=cub(1,1)/(4*lcuan^2);
              elseif norm==4  
                 cub(2:lcuan,1)=2*cub(2:lcuan,1)/(4*par*lcuan^2);
                 cub(1,2:lcuan)=2*cub(1,2:lcuan)/(4*par*lcuan^2);
                 cub(2:lcuan,2:lcuan)=4*cub(2:lcuan,2:lcuan)/(4*par*lcuan^2);
%                cub(1,1)=cub(1,1)/(4*lcuan^2);
              else
                 cub(2:lcuan,1)=cub(2:lcuan,1)/2;
                 cub(1,2:lcuan)=cub(1,2:lcuan)/2;               
              end
           

	   [dctc,cod,codigo_int,nceros,entrop,entropint]=qdct51(cub,niveles,fronteras,fc,cc,crit,frecbaja,calcent);

              if norm==1
                 dctc(2:lcuan,1)=dctc(2:lcuan,1)*cubs(1,1)/2;
                 dctc(1,2:lcuan)=dctc(1,2:lcuan)*cubs(1,1)/2;
                 dctc(2:lcuan,2:lcuan)=dctc(2:lcuan,2:lcuan)*cubs(1,1)/4;
                 dctc(1,1)=cub(1,1);
              elseif norm==2
                 dctc(2:lcuan,1)=dctc(2:lcuan,1)*Lmedia/2;
                 dctc(1,2:lcuan)=dctc(1,2:lcuan)*Lmedia/2;
                 dctc(2:lcuan,2:lcuan)=dctc(2:lcuan,2:lcuan)*Lmedia/4;
                 dctc(1,1)=cub(1,1);
              elseif norm==3
                 dctc(2:lcuan,1)=dctc(2:lcuan,1)*Lmedia/2;
                 dctc(1,2:lcuan)=dctc(1,2:lcuan)*Lmedia/2;
                 dctc(2:lcuan,2:lcuan)=dctc(2:lcuan,2:lcuan)*Lmedia/4;
                 dctc(1,1)=cub(1,1);
              elseif norm==4
                 dctc(2:lcuan,1)=dctc(2:lcuan,1)*(4*par*lcuan^2)/2;
                 dctc(1,2:lcuan)=dctc(1,2:lcuan)*(4*par*lcuan^2)/2;
                 dctc(2:lcuan,2:lcuan)=dctc(2:lcuan,2:lcuan)*(4*par*lcuan^2)/4;
                 dctc(1,1)=cub(1,1);
              else
                 dctc(2:lcuan,1)=2*dctc(2:lcuan,1);
                 dctc(1,2:lcuan)=2*dctc(1,2:lcuan);
              end

           if fla==1
              dctc(1,1)=0;
              cod(1,1)=0;
           end

           imc=idct2(dctc);
           imq=metesub(imq,[iii jjj],imc);
           dctq=metesub(dctq,[iii jjj],dctc);
           codq=metesub(codq,[iii jjj],cod);
           clear imc dctc codint nceros cod

           if calcent==1
              hache=entropint;
              Hi=Hi+propor([posai(1) posbd(1);posai(2) posbd(2)],[(ii-1)*lcuan+1 ii*lcuan+1;(jj-1)*lcuan+1 jj*lcuan+1])*prod(lados)*hache;
              H=H+propor([posai(1) posbd(1);posai(2) posbd(2)],[(ii-1)*lcuan+1 ii*lcuan+1;(jj-1)*lcuan+1 jj*lcuan+1])*prod(lados)*entrop;
           end
       end 
   end

% A ver si pesco quien es el que no sale

% simq=size(imq)
% sdct=size(dctq)
% scod=size(codq)
% scia=size(ciaf1D)
% siaf=size(iaf)
% snuq=size(nuqf)
sniv=size(niveles)
sfro=size(fronteras)
sH=size(H)
sHi=size(Hi)

ciaf1D=0;
iaf=0;
nuqf=0;