function po=sacagrup(pos,i)

% SACAGRUP extrae los datos del grupo i (extrae el i-esimo conjunto
% de filas) incluidos en una variable que tenga los datos de cada gru-
% po separados por una fila de ceros.
% Naturalmente, los datos con esta estructura NUNCA pueden contener
% (de por si) una fila de ceros, sino que esta corresponde siempre
% a un cambio de grupo.
% Los datos del grupo 1 empiezan en la primera fila (no se empieza con
% una linea de ceros).
% Ejemplos de esta organizacion son los datos de los diferentes foto-
% gramas dados por CODIAR12 o los datos de lo diferentes niveles de re-
% solucion dados por FLUXAR12.
%
% USO: datos_grupo=sacagrup(datos_tot,grupo);

s=sum(pos');
s=find(s==0);
ng=length(s)+1;
l=size(pos);
l=l(1);

if i==1    
   po=pos(1:s(i)-1,:);
elseif i<ng
   po=pos(s(i-1)+1:s(i)-1,:);
else
   po=pos(s(i-1)+1:l,:);
end

