function [ciaf1D,iaf,nuqf,niv,fro]=vqperc(tamblock,facfrec,ncontr,nolin,estabiliz,B,bitmax,fc,fijo,incluir)

%function [ciaf1D,iaf,nuqf,niv,fro]=vqperc(tamblock,facfrec,ncontr,nolin,estabiliz,B,bitmax,fc,fijo,incluir)
%
%  La cuantificacion esta controlada por una 'Funcion de Asignacion de Informacion'
%  IAF perceptual calculada mediante IAFET.
% 
%  USO: [ciaf1D,iaf,nuqf,niv,fro]=vqperc(lado bloque,facfrec,ncontr,nolin?(0/1),
%                                       estabiliz?(0/1),B,bitmax,fc,fijarmax(0/1),inclcsf(0/1));
%
%  NOTAS:
%
%   * No cuantifica los coeficientes a los que se les asigne un numero de
%     bits mayor que un cierto limite (bitmax).
%
%   * El fichero de constantes debe contener CON ESOS NOMBRES:
%      
%           ciaf1D, nuqf, contrast (y opcionalmente csf1D y iaf)
%   
% >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> DISEO PERCEPTUAL <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

s=tamblock;

fe=linspace(0,sqrt(2)*(fc-fc/s),floor(sqrt(2*(s-1)^2)+1))';
C=linspace(0,1,ncontr);

[iaf,ciaft,ciaf1D,nuqf,csf1D]=constet(fe,facfrec,0,C,nolin,estabiliz);

contras=C'*ones(1,length(fe));

ciaf1D=simrev(ciaf1D);
ciaf1D=ciaf1D/(sum(sum(ciaf1D(1:s,1:s))));


%if length(nolin)==1
%   nolin=[nolin 0 0];
%elseif length(nolin)==2
%   nolin=[nolin 0];
%end

%if nolin(3)==0
%   ciaf1D=B*ciaf1D*s*s;
%   cond=ciaf1D<=bitmax;
%   anticond=cond<1;
%   ciaf1D=cond.*ciaf1D+anticond*bitmax;
%   ciaf1D=ciaf1D(1,:);
%   N=2.^(ciaf1D);
%else
%   ciaf1D=B*ciaf1D*s*s;
%   cond=ciaf1D<=bitmax;
%   anticond=cond<1;
%   ciaf1D=cond.*ciaf1D+anticond*(2^bitmax);
%   ciaf1D=ciaf1D(1,:);
%   N=ciaf1D;
%end

ciaf1D=B*ciaf1D*s*s;
cond=ciaf1D<=bitmax;
anticond=cond<1;
ciaf1D=cond.*ciaf1D+anticond*bitmax;
ciaf1D=ciaf1D(1,:);
N=2.^(ciaf1D);

numniv=round(N);
numniv=cond(1,:).*numniv;
csf=0;
[niv,fro]=niv66(numniv,nuqf,contras,incluir,csf,fijo);

